package com.backpower.uhfqcdemo;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

import LDK.rfid.IRfid;
import androidx.fragment.app.FragmentActivity;


public class acttitleActivity extends FragmentActivity {
    String TAG = "actititleActivity";
	private Button mSendButton;
    private static final int REQUEST_CONNECT_DEVICE = 1;
    private static final int REQUEST_ENABLE_BT = 2;
    private BluetoothAdapter mBluetoothAdapter = null;
    rfid_inst rfids;Context mcontext;String lastadd;

    @Override
    public void onCreate(Bundle savedInstanceState) {
    	//requestWindowFeature(Window.FEATURE_NO_TITLE);
    	super.onCreate(savedInstanceState);
        setContentView(R.layout.start);
        mcontext = this;
        //this.setTitle("Login...");
        mSendButton = (Button) findViewById(R.id.connect);
        mSendButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                Intent serverIntent = new Intent(getApplicationContext(), DeviceListActivity.class);
                startActivityForResult(serverIntent, REQUEST_CONNECT_DEVICE);
            }
        });

        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        if (mBluetoothAdapter == null) {
            showTextToast("本设备没有蓝牙接口，APP无法运行，中止");
            finish();
            return;
        }
        String path = getDir("lib", Context.MODE_PRIVATE).getAbsolutePath();
        rfids = new rfid_inst(this,path);
        lastadd = Read_config("LastdeviceAdd");
        if(lastadd != null){
            btDeviceAdd = lastadd;
            new ConnectThread().start();
        }
    }

    String btDeviceAdd;boolean connecting = false;
    private class ConnectThread extends Thread{
        @Override
        public void run() {
            if(mBluetoothAdapter != null) {
                BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(btDeviceAdd);
                mHandler.obtainMessage(0, 0, 0,getResources().getString(R.string.connectingdevice))
                        .sendToTarget();
                connecting = true;
                rfid_inst.rfid.open(device, callb);
            }
        }
    }

    IRfid.CallbackListener callb = new IRfid.CallbackListener() {
        @Override
        public void callback(boolean b, String s) {
            Log.e(TAG, "open callback: " + s + "----" + b);
            connecting = false;
            if(b){
                //showTextToast("连接成功...");
                mHandler.obtainMessage(0, 0, 0,getResources().getString(R.string.connectok))
                        .sendToTarget();
                gotoNextActivity(btDeviceAdd);
            }else{
                //showTextToast("连接失败...");
                mHandler.obtainMessage(0, 0, 0,getResources().getString(R.string.connectfail))
                        .sendToTarget();
            }
        }
    };

    Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case 0: showTextToast(""+msg.obj);break;
            }
        }
    };

    private Toast toast = null;
    private void showTextToast(String msg) {
        if (toast == null) {
            toast = Toast.makeText(getApplicationContext(), msg, Toast.LENGTH_LONG);
            toast.setText(msg);
        } else {
            toast.setText(msg);
        }
        toast.show();
    }

    @Override
    protected void onDestroy() {
    // TODO Auto-generated method stub
    super.onDestroy();
    }

    @Override
    public void onStart() {
        super.onStart();
        Log.e(TAG, "++ ON START ++");
        if (!mBluetoothAdapter.isEnabled()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
            // Otherwise, setup the chat session
        }
    }

    private void gotoNextActivity(String deviceadd){

        Intent intent = new Intent();
        intent.putExtra("deviceadd",deviceadd);
        intent.setClass(acttitleActivity.this, MainActivity.class);
        startActivity(intent);

    }

    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        Log.d(TAG, "onActivityResult requestCode = " +requestCode+"    resultCode = "+ resultCode);
        switch (requestCode) {
            case REQUEST_CONNECT_DEVICE:
                // When DeviceListActivity returns with a device to connect
                if (resultCode == Activity.RESULT_OK) {
                    // Get the device MAC address
                    String address = data.getExtras()
                            .getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
                    Log.e(TAG,"select Device = "+address);
                    Save_config("LastdeviceAdd",address);
                    gotoNextActivity(address);
                }
                break;
            case REQUEST_ENABLE_BT:
                // When the request to enable Bluetooth returns
                if (resultCode == Activity.RESULT_OK) {
                    // Bluetooth is now enabled, so set up a chat session
                } else {
                    // User did not enable Bluetooth or an error occured
                    Log.d(TAG, "Bluetooth not enabled");
                    showTextToast(getResources().getString(R.string.mbtunenable));
                    finish();
                }
                break;
        }
    }


    String Save_config(String name,String Value){
        int diveceNum ;
        SharedPreferences share = mcontext.getSharedPreferences("perference", MODE_PRIVATE);
        SharedPreferences.Editor editor = share.edit();
        editor.putString(name, Value);
        editor.commit();
        return Value;
    }

    String Read_config(String name){
        SharedPreferences config = mcontext.getSharedPreferences("perference", MODE_PRIVATE);
        return config.getString(name, null);
    }

}